Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!
Bug 99193 - emerge -uDN world doesn't update all available packages
Summary: emerge -uDN world doesn't update all available packages
Status: VERIFIED NEEDINFO
Alias: None
Product: Portage Development
Classification: Unclassified
Component: Core - Interface (emerge) (show other bugs)
Hardware: All Linux
: High major (vote)
Assignee: Portage team
URL:
Whiteboard:
Keywords:
Depends on:
Blocks:
 
Reported: 2005-07-16 03:52 UTC by Marcel Meckel
Modified: 2009-03-02 20:38 UTC (History)
2 users (show)

See Also:
Package list:
Runtime testing required: ---


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Marcel Meckel 2005-07-16 03:52:59 UTC
Hi,

i often stumble around this and don't understand why emerge doesn't want to update all packages even when specified --deep (-D):

# emerge -pv -uDN world|grep dhcp
# emerge -pv dhcpcd

These are the packages that I would merge, in order:

Calculating dependencies ...done!
[ebuild     U ] net-misc/dhcpcd-1.3.22_p4-r11 [1.3.22_p4-r5] -build -static 148 kB

Total size of downloads: 148 kB
#

It's very often that even with -D i don't get all packages updated that could be updated.

# emerge info
Portage 2.0.51.22-r1 (default-linux/x86/2005.0, gcc-3.3.5, glibc-2.3.4.20040808-r1, 2.6.9-gentoo-r9-raid i686)
=================================================================
System uname: 2.6.9-gentoo-r9-raid i686 Intel(R) Pentium(R) 4 CPU 2.80GHz
Gentoo Base System version 1.4.16
distcc 2.16 i686-pc-linux-gnu (protocols 1 and 2) (default port 3632) [disabled]
ccache version 2.3 [disabled]
dev-lang/python:     2.3.4-r1
sys-apps/sandbox:    1.2.10
sys-devel/autoconf:  2.13, 2.59-r6
sys-devel/automake:  1.4_p6, 1.5, 1.6.3, 1.7.9-r1, 1.8.5-r3, 1.9.4
sys-devel/binutils:  2.15.92.0.2-r1
sys-devel/libtool:   1.5.10-r4
virtual/os-headers:  2.4.21-r1
ACCEPT_KEYWORDS="x86"
AUTOCLEAN="yes"
CBUILD="i686-pc-linux-gnu"
CFLAGS="-O2 -march=pentium4 -fomit-frame-pointer"
CHOST="i686-pc-linux-gnu"
CONFIG_PROTECT="/etc /usr/kde/2/share/config /usr/kde/3/share/config /usr/share/config /var/qmail/control"
CONFIG_PROTECT_MASK="/etc/gconf /etc/terminfo /etc/env.d"
CXXFLAGS="-O2 -march=pentium4 -fomit-frame-pointer"
DISTDIR="/usr/portage/distfiles"
FEATURES="autoconfig distlocks sandbox sfperms strict"
GENTOO_MIRRORS="ftp://gentoo-mirror/gentoo ftp://ftp.uni-erlangen.de/pub/mirrors/gentoo"
MAKEOPTS="-j3"
PKGDIR="/usr/portage/packages"
PORTAGE_TMPDIR="/var/tmp"
PORTDIR="/usr/portage"
SYNC="rsync://gentoo-mirror/gentoo-portage"
USE="x86 adns alsa apache2 bash-completion curl devfs26 emboss gd libg++ mp3 mysql ncurses nls pam php posix sse sse2 ssl tcpd truetype-fontstype1-fonts userland_GNU kernel_linux elibc_glibc"
Unset:  ASFLAGS, CTARGET, LANG, LC_ALL, LDFLAGS, LINGUAS, PORTDIR_OVERLAY
Comment 1 Stian Skjelstad 2005-07-16 05:19:40 UTC
are the package listed in the world list?

Do you ever (by mistake) install a program with -u or --oneshot?
Comment 2 Marcel Meckel 2005-07-16 05:22:11 UTC
I use -1 (oneshot) often. But this should only prevent world file being updated - with --deep this should 
make no difference.
Comment 3 Marcel Meckel 2005-07-16 05:25:18 UTC
(In reply to comment #1)
> are the package listed in the world list?

sorry, can't say atm. emerged dhcpcd without "-1" one hour ago and therefore it's in the world file _now_, 
but dunno if it was already in there.
Comment 4 Stian Skjelstad 2005-07-16 07:31:29 UTC
Most likely you have installed dhcpcd with -u or -1 flag. That way, world file
is not ajour, and that happens. Seen other users do that mistake too. emerge -uD
world scans all packages in world list for depencies, and all packages below
that point for updates. Untracked packages is not supposed to be affected by
this, since a user might have done this on purpose on a package the user don't
want to get installed via world list.

Please close bug, and let another REOPEN if it turns out that the package was in
world list or on a depency via world list.
Comment 5 Jakub Moc (RETIRED) gentoo-dev 2005-07-16 09:28:48 UTC
(In reply to comment #3)
> sorry, can't say atm. emerged dhcpcd without "-1" one hour ago and therefore
it's in the world file _now_, 
> but dunno if it was already in there.

Closing this bug, as there is no chance to find out what went wrong here.

Besides this dhcpcd issue, you should be aware that world != all, so even emerge
-uD world won't upgrade *all* packages on your system, it will omit stale
dependencies of already unmerged ebuilds, etc. There are quite a few duplicate
bugs about this.
Comment 6 Colin Tinker 2005-07-17 15:50:47 UTC
I have noticed this same problem of late with emerge -Du world and packages are 
in my world file.  oe example the 2.6.12-r6 kernel has been made stable and the 
above command did not update it but emerge -Du gentoo-sources did update it. 
Comment 7 Colin Tinker 2005-07-24 10:04:36 UTC
Once again I did an emerge -Du world and it did not upgrade all packages as 
kopete-3.4.1-r1 was available and was not upgraded, I had to use emerge -Du 
kopete.  I think this bug should be re opened until a reason is found for the 
cause of this.  kopete was in my world file and I do not use != all. 
Comment 8 Marcel Meckel 2006-02-18 05:03:41 UTC
Still not working as desired:

# emerge -pv -uDN world

These are the packages that I would merge, in order:

Calculating world dependencies ...done!
[ebuild     U ] sys-apps/baselayout-1.11.14-r5 [1.11.14-r4] -bootstrap -build -static -unicode 0 kB
[ebuild     U ] app-crypt/gnupg-1.4.2.1 [1.4.1] -X +bzip2* -caps +curl -ecc -idea -ldap +nls -readline (-selinux) -smartcard -static -usb +zlib 2,959 kB

Total size of downloads: 2,959 kB
# emerge -pv -u setserial sash

These are the packages that I would merge, in order:

Calculating dependencies ...done!
[ebuild     U ] sys-apps/setserial-2.17-r3 [2.17-r2] 51 kB
[ebuild     U ] app-shells/sash-3.7-r1 [3.7] -readline 49 kB

Total size of downloads: 100 kB

Why the fuck i specify -D when it does not cover _ALL_ installed packages?
I only found out about setserial and sash because i did a

# equery list

which showed my installed setserial and sash version are both masked.

# egrep -c 'setserial|sash' /var/lib/portage/world
0

setserial and sash are both not mentioned in world file since they were pulled in as dependencies of other packages. Nevertheless i want my system up2date what includes _ALL_ packages.

For baselayout it's working - emerge want's to update even it is not mentioned in world file.

Please investigate this further since there is 100% a bug.

# emerge info
Portage 2.0.54 (default-linux/x86/2005.1, gcc-3.3.6, glibc-2.3.5-r2, 2.6.14-hardened-r5 i686)
=================================================================
System uname: 2.6.14-hardened-r5 i686 Intel(R) Celeron(R) CPU 2.40GHz
Gentoo Base System version 1.6.14
ccache version 2.3 [enabled]
dev-lang/python:     2.3.5-r2, 2.4.2
sys-apps/sandbox:    1.2.12
sys-devel/autoconf:  2.13, 2.59-r6
sys-devel/automake:  1.4_p6, 1.5, 1.6.3, 1.7.9-r1, 1.8.5-r3, 1.9.6-r1
sys-devel/binutils:  2.16.1
sys-devel/libtool:   1.5.22
virtual/os-headers:  2.6.11-r2
ACCEPT_KEYWORDS="x86"
AUTOCLEAN="yes"
CBUILD="i686-pc-linux-gnu"
CFLAGS="-O2 -march=pentium4 -fomit-frame-pointer"
CHOST="i686-pc-linux-gnu"
CONFIG_PROTECT="/etc /usr/kde/2/share/config /usr/kde/3/share/config /usr/share/config /var/qmail/control"
CONFIG_PROTECT_MASK="/etc/gconf /etc/terminfo /etc/env.d"
CXXFLAGS="-O2 -march=pentium4 -fomit-frame-pointer"
DISTDIR="/usr/portage/distfiles"
FEATURES="autoconfig ccache distlocks sandbox sfperms strict"
GENTOO_MIRRORS="ftp://ftp.uni-erlangen.de/pub/mirrors/gentoo"
MAKEOPTS="-j1"
PKGDIR="/usr/portage/packages"
PORTAGE_TMPDIR="/var/tmp"
PORTDIR="/usr/portage"
SYNC="rsync://rsync.de.gentoo.org/gentoo-portage"
USE="x86 apache2 avi bash-completion berkdb bitmap-fonts bzip2 crypt curl devfs26 eds emboss encode expat foomaticdb gd gdbm gif gstreamer hardened hardenedphp idn imagemagick imap imlib jpeg junit kde libg++ mbox memlimit mhash mmx mmx2 motif mp3 mpm-prefork ncurses nls noantlr nobcel nobeanutils nobsh nocommonslogging nocommonsnet nojdepend nojsch nojython nolog4j nooro nopop3d noregexp norhino noxerces ogg oggvorbis pam pcre perl php png posix quicktime rtc sasl sse sse2 ssl tcpd tiff truetype truetype-fonts type1 type1-fonts udev vhosts vorbis xml2 xmms xv zlib userland_GNU kernel_linux elibc_glibc"
Unset:  ASFLAGS, CTARGET, LANG, LC_ALL, LDFLAGS, LINGUAS, PORTDIR_OVERLAY
Comment 9 Alec Warner archtester Gentoo Infrastructure gentoo-dev Security 2006-02-18 07:53:05 UTC
(In reply to comment #8)
> Still not working as desired:
> 
Not as desired, perhaps; but as designed?  Probably.
> # emerge -pv -uDN world
> 
> These are the packages that I would merge, in order:
> 
> Calculating world dependencies ...done!
> [ebuild     U ] sys-apps/baselayout-1.11.14-r5 [1.11.14-r4] -bootstrap -build
> -static -unicode 0 kB
> [ebuild     U ] app-crypt/gnupg-1.4.2.1 [1.4.1] -X +bzip2* -caps +curl -ecc
> -idea -ldap +nls -readline (-selinux) -smartcard -static -usb +zlib 2,959 kB
> 
> Total size of downloads: 2,959 kB
> # emerge -pv -u setserial sash
> 
> These are the packages that I would merge, in order:
> 
> Calculating dependencies ...done!
> [ebuild     U ] sys-apps/setserial-2.17-r3 [2.17-r2] 51 kB
> [ebuild     U ] app-shells/sash-3.7-r1 [3.7] -readline 49 kB
> 
> Total size of downloads: 100 kB
> 
> Why the fuck i specify -D when it does not cover _ALL_ installed packages?
> I only found out about setserial and sash because i did a

You already know it doesn't cover "_ALL_ installed packages" and then you complain when it...misses packages?

> # equery list
> 
> which showed my installed setserial and sash version are both masked.
> 
> # egrep -c 'setserial|sash' /var/lib/portage/world
> 0
> 
> setserial and sash are both not mentioned in world file since they were pulled
> in as dependencies of other packages. Nevertheless i want my system up2date
> what includes _ALL_ packages.
> 
> For baselayout it's working - emerge want's to update even it is not mentioned
> in world file.
Baselayout is in system...World = system + world file, so that is covered.
> Please investigate this further since there is 100% a bug.
Feature request for an "All" target perhaps, not entirely a bug.  However it still could be one.  What you need to do is figure out what you have installed that brought in sash and setserial.  Maybe they really are orphaned packages, maybe there is a bug.


Comment 10 Marius Mauch (RETIRED) gentoo-dev 2006-02-18 15:21:50 UTC
sash and setserial system used to be in system some time ago but have been removed/replaced since then.
Comment 11 Stian Skjelstad 2006-02-18 19:39:47 UTC
Doesn't emerge --depclean remove those packages for you?
Comment 12 Marius Mauch (RETIRED) gentoo-dev 2006-02-18 20:28:31 UTC
It should, I guess the OP hasn't run --depclean for while (if ever).
Comment 13 Marius Mauch (RETIRED) gentoo-dev 2007-01-11 11:01:33 UTC
Closing due to old age
Comment 14 Steffen Hau 2009-03-02 12:58:00 UTC
Hi,

I have this issue at the moment with virtual/perl-Module-Build. I wanted to deplcean my system and it said:

 * Dependencies could not be completely resolved due to
 * the following required packages not being installed:
 * 
 *   ~perl-core/Module-Build-0.31.012 pulled in by:
 *     virtual/perl-Module-Build-0.31.012
 * 

I did, what depclean told me (--update --newuse --deep @system @world) and it said:

emerge -puvDN @system @world

These are the packages that would be merged, in order:

Calculating dependencies... done!

eix said:

# eix virtual/perl-Module-Build
[I] virtual/perl-Module-Build
     Available versions:  (~)0.28-r1 0.28.08 (~)0.30 (~)0.31 (~)0.31.012
     Installed versions:  0.31.012(13:49:06 02.03.2009)
     Homepage:            http://www.gentoo.org/proj/en/perl/
     Description:         Build and install Perl modules

But there is actual an ebuild for version 0.32:

emerge -pv perl-Module-Build

These are the packages that would be merged, in order:

Calculating dependencies... done!
[ebuild     U ] virtual/perl-Module-Build-0.32 [0.31.012] 0 kB

perl-core/Module-Build is installed with version 0.32.

eix Module-Build
[D] perl-core/Module-Build
     Available versions:  (~)0.28-r1 0.28.08 (~)0.30 (~)0.31 (~)0.31.012
     Installed versions:  0.32(16:36:20 26.02.2009)
     Homepage:            http://search.cpan.org/search?query=Module-Build&mode=dist
     Description:         Build and install Perl modules

Comment 15 Zac Medico gentoo-dev 2009-03-02 20:38:45 UTC
(In reply to comment #14)
>  * Dependencies could not be completely resolved due to
>  * the following required packages not being installed:
>  * 
>  *   ~perl-core/Module-Build-0.31.012 pulled in by:
>  *     virtual/perl-Module-Build-0.31.012
>  * 
> 
> I did, what depclean told me (--update --newuse --deep @system @world) and it
> said:
> 
> emerge -puvDN @system @world

In this particular case you need to use --with-bdeps=y in order for the perl-Module-Build update to get pulled in. It is a rare case which is triggered by buildtime dependencies being updated for a package that you have previously installed. In cases like this, the installed package assumes the new dependencies due to the issue discussed in bug #239006, comment #4.